﻿namespace HeuristicLab.Problems.ProgramSynthesis.Base.Erc.Char {
  using System;

  using Common;
  using Core;
  using Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public class CharErcOptions : ErcOptionConvertible<char, int> {
    public CharErcOptions() { }

    public CharErcOptions(params WeightedErcItem<int>[] values) : this(true, values) { }

    public CharErcOptions(bool isEnabled, params WeightedErcItem<int>[] values) : base(isEnabled, values) { }

    [StorableConstructor]
    protected CharErcOptions(bool deserializing) : base(deserializing) { }

    public CharErcOptions(CharErcOptions origin, Cloner cloner) : base(origin, cloner) { }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new CharErcOptions(this, cloner);
    }

    public override char GetErcValue(IRandom random) {
      return GetErcValue(random, Convert.ToChar);
    }

    public override string ToString() {
      return "Char";
    }
  }
}
